/* @(#) $Id: LCD_armlet.c,v 1.4 2007/04/27 16:01:26 arpruss Exp $ */

#include <Standalone.h>
#include <PalmOS.h>
#include <PceNativeCall.h>
#include "Backup_Res.h"
#include "endianutils.h"
#define PtrByteSwap32( x ) ( ( void* )ByteSwap32( ( UInt32 )( x ) ) )
//#pragma thumb off
STANDALONE_CODE_RESOURCE_ID( armLCD );

#define STUB( a, b, c ) asm(".global " #a); asm(#a ":"); asm("ldr r12, [r9,#-" #b "]"); asm("ldr pc, [r12,#" #c "]");

Err HALDisplayGetAttributes(UInt16 attr, UInt32 *valueP);
Err HALDisplaySetAttributes(UInt16 attr, UInt32 value);
#define halDisplayAttributeBrightness		0x12	/* settable */
#define halDisplayAttributeBacklight		0x11	/* settable */

UInt32 NativeFunction
    (
    const void*      emulStateP,
    void*            userData68KP,
    Call68KFuncType* call68KFuncP
    )
{
    if ( ( UInt32 )userData68KP == 0 ) {
        UInt32 value;
        HALDisplayGetAttributes( halDisplayAttributeBrightness, &value );
        FtrSet( appCreator, FTR_BRIGHTNESS, value );
        HALDisplaySetAttributes( halDisplayAttributeBrightness, 0 );
    }
    else {
        UInt32 value;
        FtrGet( appCreator, FTR_BRIGHTNESS, &value );
        HALDisplaySetAttributes( halDisplayAttributeBrightness, value );
    }

    return 0;
}


STUB(HALDisplaySetAttributes,4,0x34)
STUB(HALDisplayGetAttributes,4,0x2C)
STUB(FtrSet,8,0x43C)
STUB(FtrGet,8,0x424)
