#!/usr/bin/perl

$filename = $ARGV[0];
$arrayname = $ARGV[1];


open (INPUTFILE, "<$filename") or die "Could not open $filename";
binmode INPUTFILE;

$filesize = (stat(INPUTFILE))[7];

print "const unsigned char $arrayname" . "[$filesize] __attribute__((aligned(4)))= \n{\n";

$linecounter = 0;
read INPUTFILE, $filedata, 1;
printf "  0x%02x", unpack "C", $filedata;

while (read INPUTFILE, $filedata, 1)
{
    $linecounter++;
    if (12 == $linecounter)
    {
        $linecounter = 0;
        printf ",\n  0x%02x", unpack "C", $filedata;
    } else
    {
        printf ", 0x%02x", unpack "C", $filedata;
    }
}

print "\n};\n";

close (INPUTFILE);
