#ifndef _FTP_H
#define _FTP_H

#include "sects.h"

FTP_SECTION Boolean FTPFetchToVFS( Char* remoteName, UInt16 vol, const Char* localPath );
FTP_SECTION Boolean FTPPWD( Char* dest, UInt16 maxLength );
FTP_SECTION Char** FTPDirList( Int32* numEntriesP, Boolean subDirOnly );
FTP_SECTION Boolean FTPRename( const Char* src, const Char* dest );
FTP_SECTION Boolean FTPRmDir( Char* dir );
FTP_SECTION Boolean FTPMkDir( Char* dir );
FTP_SECTION Boolean FTPChDir( Char* dir );
FTP_SECTION Boolean FTPDelete( Char* file );
FTP_SECTION Boolean FTPFileCheck( const Char* name );
FTP_SECTION void FTPClose( void );
FTP_SECTION UInt16 FTPResponse( void );
FTP_SECTION UInt16 FTPCommand( Char* command );
FTP_SECTION Boolean NetOpen( void );
FTP_SECTION void  NetClose( void );
FTP_SECTION Boolean FTPPassive( void );
FTP_SECTION Boolean FTPBinary( Boolean binary );
FTP_SECTION Boolean FTPSendFromVFS( const Char* dest, UInt16 vol, const Char* path );
FTP_SECTION Boolean FTPOpen( Char* hostName, Char* userName, Char* password, UInt16 port );
FTP_SECTION Boolean FTPFetchString( const Char* name, UInt32 bufferSize, Char* s );
FTP_SECTION void Linger( NetSocketRef socket, Boolean state, UInt16 time );
FTP_SECTION void NetCloseImmediate( void );
Boolean Print( Char* hostName );

extern Boolean netOpen;
#endif
